#ifndef __SCANNER_H__
#define __SCANNER_H__

#include <stdio.h> /* FILE */

enum {
    SCANNED_ERR = 1,                /* unspecified parse error */
    SCANNED_ERR_CHAR_TTYPE_AS_START,/* char token type for a start var */
    SCANNED_ERR_CHAR_TTYPE_AS_PRODUCTION_HEAD,
    SCANNED_ERR_UNTERM_COMMENT,     /* unterminated comment */
    SCANNED_ERR_UNTERM_PRODUCTION,  /* unterminated production */
    SCANNED_NAMED_TOKEN_TYPE_DEF,
    SCANNED_START_ID_DEF,
    SCANNED_PRODUCTION_HEAD,
    SCANNED_PBODY_IDENTIFIER,       /* a named token type or a nonterminal */
    SCANNED_PBODY_CHAR_TOKEN_TYPE,  /* a token type (`'x'') */
    SCANNED_PBODY_PIPE,             /* `|' */
    SCANNED_PRODUCTION_END          /* production ended */
};

#ifdef YY_FLEX_LEX_COMPAT
extern char yytext[];
#else /* YY_FLEX_LEX_COMPAT */
extern char *yytext;
#endif /* YY_FLEX_LEX_COMPAT */
extern int   yyleng;
extern int   yylineno;
extern FILE *yyin;

extern int yylex(void);


#endif /* __SCANNER_H__ */
